#!BPY

"""
Name: 'Animator'
Blender: 237a
Group: 'Misc'
Tooltip: 'Generating animations for testing MultiCamera system @CMP'
"""

__author__ = "Mazany Ondrej"
__url__ = "http://cmp.felk.cvut.cz/~mazano1/"
__version__ = "v.0.9"
__email__ = "mazany.o@seznam.cz"
__bpydoc__ = """\
-------------------------------------------------------------------
This is a main script of the animator project at CMP
-------------------------------------------------------------------
"""
#------------------------------------------------------------------
# - CODE - CODE - CODE - CODE - CODE - CODE - CODE - CODE - CODE -
#------------------------------------------------------------------

# importing modules
from parsecam import *  # contains rutines for loading camera parameters, etc.
from bfunc import * # basic functions
from parseanim import * # loading and parsing animation xml file
import Blender  # Blender API import
import os   # OS rutines

global outputpath; # global variable, where the rendered images will be stored



# ==========================================
# ======         Run code             ======
# ==========================================
print "==============================================================================="
print "Starting..."
print

# Geting the cameras file and parse it
camfiles = os.getenv("cameras")
print "-------------------------------------------------------------------------------"
if (( camfiles == "") or (camfiles == None)) :
    print "!! Warning: you didn't specify camera file, trying to use path 'cameras' !!"
    camfiles = "cameras"
print "..parsing the camera files in %s path .." % camfiles
cameras=parsecam(camfiles)
print "-------------------------------------------------------------------------------"
print

# Writing cameras calibration matrices
print "-------------------------------------------------------------------------------"
print "..writing the camera calibration matrix files into %s path .." % camfiles
writePcalMatrices(camfiles,cameras)
print "-------------------------------------------------------------------------------"

# Geting the animation file nad parse it
print "-------------------------------------------------------------------------------"
animfile = os.getenv('animation')
if (( animfile == "") or (animfile == None)) :
    print "!! Warning: you didn't specify animation file, trying to use 'examples/animation.xml' !!"
    animfile = "examples/animation.xml"
print "..parsing the animation file %s .." % animfile
parseanim(animfile)
print "-------------------------------------------------------------------------------"
print

# Setting the animation
print "-------------------------------------------------------------------------------"
print "..setting up animation..."
print "-------------------------------------------------------------------------------"
setUpFrames()
print "-------------------------------------------------------------------------------"
print

# Get the output path and Render animation
print "-------------------------------------------------------------------------------"
print "..rendering.."
print "-------------------------------------------------------------------------------"
outputpath = os.getenv('render')
if ((outputpath == "") or (outputpath == None)) :
    print "!! Warning: you didn't specify outputpath, will use '/tmp/animation' !!"
    outputpath = "/tmp/animation"
runRender(outputpath,cameras)
print "-------------------------------------------------------------------------------"
print

# END
print "End."
print "==============================================================================="
